#!/bin/sh

system=`uname`

if [ "x$system" == 'xDarwin' ]; then
	SYS_MAC="SYS_MAC";
	TARGET=DRMAA.bundle
else
    TARGET=DRMAA.so
fi

if [ -z $GW_LOCATION ]; then
        echo "GW_LOCATION must be defined"
fi

if [ ! -f drmaa_perl_wrap.c ]; then
        echo "Generating swig wrapper."
        swig -perl5 -exportall -I$GW_LOCATION/include drmaa_perl.i
fi

PERL_LIBS=`perl -e 'use Config;print $Config{archlibexp};'`/CORE

if [ -z $SYS_MAC ]; then
	gcc -shared -o $TARGET -fPIC -D_REENTRANT -D_GNU_SOURCE -L$GW_LOCATION/lib -I$GW_LOCATION/include -I/usr/include -I$PERL_LIBS -ldrmaa -lnsl -lm -lpthread drmaa_perl_wrap.c
else
	gcc -bundle -o $TARGET -L$GW_LOCATION/lib -I$GW_LOCATION/include -I/usr/include -I$PERL_LIBS -L$PERL_LIBS -lperl -ldrmaa -lm -lpthread drmaa_perl_wrap.c
fi

COMPILE_STATUS=$?

if [ "x$COMPILE_STATUS" == "x0" ]; then
    mkdir -p $GW_LOCATION/lib/perl
    cp $TARGET $GW_LOCATION/lib/perl
    cp DRMAA.pm $GW_LOCATION/lib/perl
else
    echo Error compiling DRMAA bindings.
fi
